﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace BladhusClassLibrary
{
    [DataContract(IsReference=true)]
    public class Abonnement
    {
        internal Abonnement(string betalingsform, float rabatsats, Blad bladet, Kunde kunden)    // constructor
        {
            this.Betalingsform = betalingsform;
            this.Rabatsats = rabatsats;

            this.bladet = bladet;       // tilknyt
            this.kunden = kunden;       // tilknyt

            this.bladet.AssocierAbonnement(this);   // sørg også for tylknytning fra bladet / kunden antages selv at gøre det
        }

        public override string ToString()
        {
            return "" + this.Betalingsform + "; " + this.Rabatsats + "; " + this.kunden.Navn + "; " + this.bladet.BladNavn;
        }

        #region selve abonnementes data og metoder fra domain beskrivelsen

        [DataMember]
        public string Betalingsform { get; private set; }
        [DataMember]
        public float Rabatsats { get; private set; }

        public void RetStamdata(string betalingsform, float rabatsats)
        {
            this.Betalingsform = betalingsform;
            this.Rabatsats = rabatsats;
        }

        #endregion

        #region forbindelser til tilknyttede kunde og blad

        [DataMember]
        private Kunde kunden;

        [DataMember]
        private Blad bladet;

        public Kunde FindKunden()
        {
            return this.kunden;
        }

        public Blad FindBladet()
        {
            return this.bladet;
        }

        #endregion
    }
}
