﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace BladhusClassLibrary
{
    [DataContract(IsReference = true)]
    public class BladKartotek
    {
        [DataMember]
        private List<Blad> alleBladene = new List<Blad>();

        public Blad OpretBlad(string navn, string udgivelsesfrekvens)
        {
            Blad nyBlad = new Blad(navn,udgivelsesfrekvens);
            this.alleBladene.Add(nyBlad);
            return nyBlad;
        }

        public List<Blad> FindAlleBlade()
        {
            return new List<Blad>(this.alleBladene);       // vigtigt - ny liste med alle
        }

        public Blad FindBladMedNavn(string valgtNavn)
        {
            valgtNavn = valgtNavn.ToLower();
            foreach (Blad etBlad in alleBladene)
            {
                if (etBlad.BladNavn.ToLower() == valgtNavn)
                    return etBlad;
            }
            return null;
        }

        public List<Blad> FindAlleMedUdgivelsesFrekvens(string valgtUdgivelsesfrekvens)
        {
            valgtUdgivelsesfrekvens = valgtUdgivelsesfrekvens.Trim().ToLower();
            List<Blad> fundneBlade = new List<Blad>();
            foreach (Blad etBlad in alleBladene)
            {
                if (etBlad.Udgivelsesfrekvens.ToLower() == valgtUdgivelsesfrekvens)
                    fundneBlade.Add(etBlad);
            }
            return fundneBlade;
        }
    }
}
